<?php

namespace Ardent\Undercurrent\Config;

class GenericConfig
{
    public function __construct(
        private readonly array $config,
    )
    {
    }

    public function get(string $key): mixed
    {
        $keys = explode('.', $key);
        $value = $this->config;
        foreach ($keys as $key) {
            if (!isset($value[$key])) {
                throw new \InvalidArgumentException("Key '$key' not found in config");
            }
            $value = $value[$key];
        }
        return $value;
    }
}