<?php

namespace Ardent\Undercurrent\Console;

use Ardent\Undercurrent\Attribute\Command;
use ReflectionAttribute;
use ReflectionClass;

class CommandsConfig
{
    private array $commands = [];

    public function add(string $commandClass): self
    {
        $reflectionClass = new ReflectionClass($commandClass);

        $attributes = $reflectionClass->getAttributes(Command::class, ReflectionAttribute::IS_INSTANCEOF);

        if (count($attributes) === 0) {
            return $this;
        }

        $command = $attributes[0]->newInstance();

        $this->commands[] = [
            $command,
            $commandClass,
        ];

        return $this;
    }

    /**
     * @return array<array{Command, string}>
     */
    public function getCommands(): array
    {
        return $this->commands;
    }
}