<?php

namespace Ardent\Undercurrent\Console;

use Ardent\Undercurrent\Container\ContainerInterface;

class Console
{
    public function __construct(
        private readonly ContainerInterface $container,
    )
    {
    }

    public function run(): void
    {
        $argv = $_SERVER['argv'];
        $command = $argv[1] ?? '';

        $output = new Output();

        if (empty($command)) {
            $output->printLine('No command defined');
            return;
        }

        $config = $this->container->get(CommandsConfig::class);

        foreach ($config->getCommands() as [$commandConfig, $commandClass]) {
            if ($commandConfig->signature === $command) {
                $commandInstance = $this->container->get($commandClass);
                $commandInstance->execute($output);
                return;
            }
        }

        $output->printLine(sprintf('Command not found: "%s"', $command));
    }
}